#ifndef __NATIVES_H__
#define __NATIVES_H__

/* bool __thiscall CTerrorPlayer::HandleCommand_JoinTeam(CBaseEntity *_pEntity, int _iTeam, int _iSurvivorCharacter, bool _bForcedJoinSurvivorTeam) */
cell_t ShareHandleCommand_JoinTeam(IPluginContext* _pContext, const cell_t* _pParams)
{
	if (!fHandleCommand_JoinTeam)
	{
		_pContext->ThrowNativeError("can't use this function, can't found signature");
		return false;
	}

	cell_t iClientIndex = _pParams[1];
	cell_t iTeamIndex = _pParams[2];
	cell_t iCharacter = _pParams[3];
	cell_t iForce = _pParams[4];
	bool bForce = iForce ? true : false;

	edict_t* pEdict = gamehelpers->EdictOfIndex(iClientIndex);
	if (!pEdict)
	{
		_pContext->ThrowNativeError("<HandleCommand_JoinTeam> client index<%d> is invalid edict.");
		return false;
	}

	CBaseEntity* pEntity = g_pGameEntitys->EdictToBaseEntity(pEdict);
	if (!pEntity)
	{
		_pContext->ThrowNativeError("<HandleCommand_JoinTeam> client index<%d> is invalid entity.");
		return false;
	}
	
	return fHandleCommand_JoinTeam(pEntity, iTeamIndex, iCharacter, bForce);
}

/* CBaseEntity* __cdecl NextBotCreatePlayerBotSurvivorBot(const char *src) */
cell_t ShareNextBotCreatePlayerBotSurvivorBot(IPluginContext* _pContext, const cell_t* _pParams)
{
	if (!fNextBotCreatePlayerBotSurvivorBot)
	{
		_pContext->ThrowNativeError("can't use this function, can't found signature");
		return false;
	}

	cell_t iBotIndex = -1;
	CBaseEntity* pEntity = NULL;
	char *szName = NULL;
	_pContext->LocalToString(_pParams[2], &szName);

	pEntity = fNextBotCreatePlayerBotSurvivorBot(szName);

	if (pEntity)
	{
		edict_t* pEdict = g_pGameEntitys->BaseEntityToEdict(pEntity);
		if (pEdict)
		{
			iBotIndex = gamehelpers->IndexOfEdict(pEdict);
		}
		else
		{
			_pContext->ThrowNativeError("Create Bot failed. code: 2");
		}
	}
	else
	{
		_pContext->ThrowNativeError("Create Bot failed. code: 1");
	}

	return iBotIndex;
}

/* void* __thiscall  CTerrorPlayer::RoundRespawn(CBaseEntity*) */
cell_t ShareCTerrorPlayerRoundRespawn(IPluginContext* _pContext, const cell_t* _pParams)
{
	if (!fCTerrorPlayerRoundRespawn)
	{
		_pContext->ThrowNativeError("can't use this function, can't found signature");
		return false;
	}

	cell_t iClientIndex = _pParams[1];
	edict_t* pEdict = gamehelpers->EdictOfIndex(iClientIndex);
	if (!pEdict)
	{
		_pContext->ThrowNativeError("<HandleCommand_JoinTeam> client index<%d> is invalid edict.");
		return false;
	}

	CBaseEntity* pEntity = g_pGameEntitys->EdictToBaseEntity(pEdict);
	if (!pEntity)
	{
		_pContext->ThrowNativeError("<HandleCommand_JoinTeam> client index<%d> is invalid entity.");
		return false;
	}

	void* result = fCTerrorPlayerRoundRespawn(pEntity);
	return true;
}

sp_nativeinfo_s g_theAppNatives[] =
{
	{ "HandleCommand_JoinTeam", ShareHandleCommand_JoinTeam },
	{ "NextBotCreatePlayerBotSurvivorBot", ShareNextBotCreatePlayerBotSurvivorBot },
	{ "CTerrorPlayerRoundRespawn", ShareCTerrorPlayerRoundRespawn },
	{ "", NULL },
};

#endif